/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupScopeAssignment type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupScopeAssignment{}

// GroupScopeAssignment struct for GroupScopeAssignment
type GroupScopeAssignment struct {
	GroupId *string `json:"groupId,omitempty"`
	ScopeId *string `json:"scopeId,omitempty"`
	Builtin *bool   `json:"builtin,omitempty"`
}

// NewGroupScopeAssignment instantiates a new GroupScopeAssignment object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupScopeAssignment() *GroupScopeAssignment {
	this := GroupScopeAssignment{}
	return &this
}

// NewGroupScopeAssignmentWithDefaults instantiates a new GroupScopeAssignment object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupScopeAssignmentWithDefaults() *GroupScopeAssignment {
	this := GroupScopeAssignment{}
	return &this
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *GroupScopeAssignment) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupScopeAssignment) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *GroupScopeAssignment) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *GroupScopeAssignment) SetGroupId(v string) {
	o.GroupId = &v
}

// GetScopeId returns the ScopeId field value if set, zero value otherwise.
func (o *GroupScopeAssignment) GetScopeId() string {
	if o == nil || IsNil(o.ScopeId) {
		var ret string
		return ret
	}
	return *o.ScopeId
}

// GetScopeIdOk returns a tuple with the ScopeId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupScopeAssignment) GetScopeIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScopeId) {
		return nil, false
	}
	return o.ScopeId, true
}

// HasScopeId returns a boolean if a field has been set.
func (o *GroupScopeAssignment) HasScopeId() bool {
	if o != nil && !IsNil(o.ScopeId) {
		return true
	}

	return false
}

// SetScopeId gets a reference to the given string and assigns it to the ScopeId field.
func (o *GroupScopeAssignment) SetScopeId(v string) {
	o.ScopeId = &v
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *GroupScopeAssignment) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupScopeAssignment) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *GroupScopeAssignment) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *GroupScopeAssignment) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o GroupScopeAssignment) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupScopeAssignment) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.GroupId) {
		toSerialize["groupId"] = o.GroupId
	}
	if !IsNil(o.ScopeId) {
		toSerialize["scopeId"] = o.ScopeId
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableGroupScopeAssignment struct {
	value *GroupScopeAssignment
	isSet bool
}

func (v NullableGroupScopeAssignment) Get() *GroupScopeAssignment {
	return v.value
}

func (v *NullableGroupScopeAssignment) Set(val *GroupScopeAssignment) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupScopeAssignment) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupScopeAssignment) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupScopeAssignment(val *GroupScopeAssignment) *NullableGroupScopeAssignment {
	return &NullableGroupScopeAssignment{value: val, isSet: true}
}

func (v NullableGroupScopeAssignment) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupScopeAssignment) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
